﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'Table
	Public DBTable As B4XTable
	Dim RowIDList As List
	Private headers As List							' holds list of headers on csv file
	Private OldRowID As Long
	Private SelectionColor As Int = 0xFF009DFF
	Private lblDBName As Label
	Private RowIDSelected As Long					'global long value for row selected
	Private ColIDSelected As String			   	'global stringvalue for name of column selected
	Private ColNoSelected As Int

	
	'buttons

	Private btnEsc As Button
	Private btnMoveUp As Button
	Private btnMoveDown As Button
	Private btnTableUp As Button
	Private btnTableDwn As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("DBPanel")
	headers.Initialize
	CreateDBTable
	LoadData
	StoreRowIDs
End Sub


Sub Activity_Resume

End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub

'===========================================================================
' TABLE creation
'==============================================================================
' Creates the table
Sub CreateDBTable
	Log("CreateDBTable")
	DBTable.HeaderColor=Colors.RGB(32,179,220)
	DBTable.HeaderTextColor=Colors.Blue
	DBTable.GridColor=Colors.Gray
	DBTable.TextColor=Colors.Black
	DBTable.EvenRowColor=Colors.LightGray
	DBTable.MaximumRowsPerPage=13
	DBTable.ArrowsDisabledColor=Colors.Black
	DBTable.ArrowsEnabledColor=Colors.Black
	DBTable.NumberOfFrozenColumns=Starter.FrozenCols

	For i = 0 To Starter.TotColNumber - 1
		DBTable.AddColumn(Starter.ColNames(i), DBTable.COLUMN_TYPE_TEXT)
	Next
     
End Sub

' Loads the data from Table Data
Sub LoadData
	Log("Load DB Data")
	lblDBName.Text=Starter.DBName
	DBTable.SetData(Starter.TableData)
	DBTable.ClearDataView
End Sub

'Reads the database IDs in RowIDList
Sub StoreRowIDs
	Log("Store Row IDs")
	RowIDList.Initialize										'initialize the rowID list
	Private rs As ResultSet
	rs = DBTable.sql1.ExecQuery("SELECT RowID FROM data")
	Do While rs.NextRow
		RowIDList.Add(rs.GetInt2(0))								'add the rowid's to the rowID list
	Loop
	rs.Close															'close the ResultSet, we don't need it anymore
	'Log("RowIdList Size " & RowIDList.Size)
End Sub

'====================================================================================
'ROW SELECTION AND COLOUR CHANGE
'=====================================================================================
'Changes the colour of the row
Sub DBTable_CellClicked (ColumnId As String, RowId As Long)
	Log("Cell Clicked")
	RowIDSelected= RowId											' Assigns to global constant
Log(RowIDSelected)
	ColIDSelected = ColumnId
	ColNoSelected = DBTable.Columns.IndexOf(DBTable.GetColumn(ColIDSelected))      ' Gets number of Column
	RowChangeColourSelect
End Sub

'Decides colour change of the row, and deletes colour on previous selected row
Sub RowChangeColourSelect
	Dim Index As Int
	Select True
		Case RowIDSelected = OldRowID                                ' Same so remove
			Index=DBTable.VisibleRowIds.IndexOf(RowIDSelected)
			SetRowColor(Index, False)
		Case RowIDSelected<>OldRowID
			Index=DBTable.VisibleRowIds.IndexOf(RowIDSelected)      ' Set new colour
			SetRowColor(Index, True)
			Index=DBTable.VisibleRowIds.IndexOf(OldRowID)           ' remove the old colour
			SetRowColor(Index, False)
	End Select
	OldRowID=RowIDSelected
End Sub


 'Sets the color of the row
Sub SetRowColor(RowIndex As Int, Selected As Boolean)
	'Log("Set Row Colour")
	Dim clr As Int
	If Selected Then
		clr = SelectionColor
	Else If RowIndex Mod 2 = 0 Then
		clr = DBTable.EvenRowColor
	Else
		clr = DBTable.OddRowColor
	End If
	If RowIndex>-1 Then
		For Each c As B4XTableColumn In DBTable.VisibleColumns
			Dim pnl As B4XView = c.CellsLayouts.Get(RowIndex + 1) '+1 because of the header
			pnl.Color = clr
		Next
	End If
End Sub


'=================================================================================
'DATA Modification
'===================================================================================
'ADD a value to a cell at the row and column selected
Sub AddCellData (Value As String, RowNo As Int, ColName As String)
	'Log("Add Cell Data")
	Dim column As B4XTableColumn = DBTable.GetColumn(ColName)
	DBTable.sql1.ExecNonQuery2($"UPDATE data SET ${column.SQLID} = ? WHERE rowid = ?"$, Array As String(Value, RowNo))
	DBTable.ClearDataView								 'Updates the rows count.
End Sub

'============================================================================================
' Table Recovery
'===============================================================================================
'puts the data for each row into TableData
' Note  
'	a)	rs.nextRow only cycles througn filled rows as on deletion of a row the
'		row index is eliminated
'	b) rs.Getstring2(0) will return the row index,
Sub GetTableData
	Log("GetTableData")
	Dim o() As Object = DBTable.BuildQuery(False)
	Dim rs As ResultSet = DBTable.sql1.ExecQuery2(o(0),o(1))
	Dim RowCount As Int =0
	Starter.TableData.Initialize                       ' clears table data
	Do While rs.NextRow
		Dim RowList As List
		RowList.Initialize
		For i = 1 To Starter.TotColNumber           ' Column numbers a 1 to ............
			Dim Cell As String = rs.GetString2(i)    ' returns string of cells in columns
			RowList.Add(Cell)                       ' adds to the rowlist
		Next
		Starter.TableData.Add(RowList)					' adds on rows
		RowCount=RowCount+1
	Loop
	Starter.TotDBRowCount = RowCount				'Counts the number of rows saved
End Sub

'===========================================================================================
'BUTTONS
'============================================================================================

' Closes the activity so a return creates a clean DB table
Sub btnEsc_Click
	GetTableData                           ' puts data into a general list
	Select Starter.DBName
		Case "EQUIPMENT"
			EquipInfo.SaveDBEquipment
	End Select
	DBTable.Clear
	Activity.Finish                          ' Allows for total rebuild with new database
End Sub

'===============================================================================================
' Navigation Buttons
'================================================================================================
' Scrolls the Table 
Sub btnTableUp_Click
	RowChangeColourSelect
	DBTable.CurrentPage = DBTable.CurrentPage - 1
	Log(DBTable.CurrentPage)
End Sub

Sub btnTableDwn_Click
	RowChangeColourSelect
	DBTable.CurrentPage = DBTable.CurrentPage + 1
	Log(DBTable.CurrentPage)
End Sub

' Moves the row up
Sub btnMoveUp_Click
	Log(RowIDSelected)
If RowIDSelected>1 Then
	Dim SelectedData As Map = DBTable.GetRow(RowIDSelected)
	Dim ToData As Map = DBTable.GetRow(RowIDSelected-1)
	For i = 0 To DBTable.Columns.Size-1
		AddCellData(SelectedData.Get(Starter.ColNames(i)),RowIDSelected-1,Starter.ColNames(i))
		AddCellData(ToData.Get(Starter.ColNames(i)),RowIDSelected,Starter.ColNames(i))
	Next
	RowIDSelected = RowIDSelected -1
		StoreRowIDs
	If RowIDSelected<0 Then
		RowIDSelected = 0
	End If	
	StoreRowIDs
	RowChangeColourSelect
End If
End Sub

' Returns the index of the selected cell on the list
Sub FindRowIDIndex(RowID As Int) As Int
	For i = 0 To RowIDList.Size-1
		If RowID = RowIDList.Get(i) Then
			Return i
		End If
	Next
End Sub

' Row Selected is Id of row clicked
Sub btnMoveDown_Click
	Log("Row In   :" & RowIDSelected)
	If RowIDSelected<DBTable.mCurrentCount Then
		' Gets the data
		Dim SelectedData As Map = DBTable.GetRow(RowIDSelected)
		Dim ToRowID As Int = RowIDList.Get(FindRowIDIndex(RowIDSelected+1))			' Finds the next rowID
		Dim ToData As Map = DBTable.GetRow(ToRowID)
		'Swap the rows
		For i = 0 To DBTable.Columns.Size-1
			AddCellData(SelectedData.Get(Starter.ColNames(i)),ToRowID,Starter.ColNames(i))
			AddCellData(ToData.Get(Starter.ColNames(i)),RowIDSelected,Starter.ColNames(i))
		Next		
		RowIDSelected = ToRowID              ' Set selected to next ID
		StoreRowIDs
		RowChangeColourSelect                ' alter the colour
	End If
	
	
	'Attempt Number 2054!
	Dim Index As Int = DBTable.VisibleRowIds.IndexOf(RowIDSelected)
   ' Index changes to -1 on currentpage change	
	If Index = -1 Then
		Log("Page Change")
		DBTable.CurrentPage=DBTable.CurrentPage+1
		Log("Row ID " & RowIDSelected)
		Log("First Row Index " & DBTable.FirstRowIndex)
		Log("PageChangeIndex " & DBTable.VisibleRowIds.IndexOf(RowIDSelected))
		RowChangeColourSelect
	End If

End Sub

